/********************************************************************* 
  
   fasttrak.h -- PROMISE FastTrak Controllers device driver for Linux.

   Copyright (C) 2002-2005 PROMISE Technology, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   Bugs/Comments/Suggestions should be mailed to:                            
   support@promise.com.tw

   For more information, goto:
   http://www.promise.com

*********************************************************************/

#ifndef _ft3xx_h
#define _ft3xx_h

#include <linux/version.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
#define ft3xx {							\
	next: NULL,						\
	proc_dir: NULL, 					\
	proc_info: NULL,    				        \
	name: "ft3xx",						\
	detect: ft3xx_detect,					\
	release: ft3xx_release,					\
	ioctl: ft3xx_ioctl,					\
	info: NULL,					        \
	command: NULL,						\
	queuecommand: ft3xx_queuecommand,			\
	eh_abort_handler : ft3xx_abort_eh,			\
	eh_device_reset_handler : ft3xx_reset_eh,		\
	abort: ft3xx_abort,					\
	reset: ft3xx_reset,					\
	slave_attach: NULL,					\
	bios_param: ft3xx_bios_param,				\
	can_queue: Can_Queue,	/* max simultaneous cmds      */\
	this_id: 7,		/* scsi id of host adapter    */\
	sg_tablesize: Max_SG_Table - 2,/* max scatter-gather cmds    */\
	cmd_per_lun: 1,		/* cmds per lun (linked cmds) */\
	present: 0,						\
	unchecked_isa_dma: 0,	/* no memory DMA restrictions */\
	use_clustering: 0,					\
        use_new_eh_code: 0, 	/* enable this field next time*/\
        emulated: 0, 						\
        proc_name: "ft3xx" 					\
} 
#else
#define ft3xx {							\
	next: NULL,						\
	proc_dir: NULL, 					\
	proc_info: NULL,    				        \
	name: "ft3xx",						\
	detect: ft3xx_detect,					\
	release: ft3xx_release,					\
	ioctl: ft3xx_ioctl,					\
	info: NULL,					        \
	command: NULL,						\
	queuecommand: ft3xx_queuecommand,			\
	eh_abort_handler : ft3xx_abort_eh,			\
	eh_device_reset_handler : ft3xx_reset_eh,		\
	abort: ft3xx_abort,					\
	reset: ft3xx_reset,					\
	slave_attach: NULL,					\
	bios_param: ft3xx_bios_param,				\
	can_queue: Can_Queue,	/* max simultaneous cmds      */\
	this_id: 7,		/* scsi id of host adapter    */\
	sg_tablesize: Max_SG_Table - 2,	/* max scatter-gather cmds    */\
	cmd_per_lun: 1,		/* cmds per lun (linked cmds) */\
	present: 0,						\
	unchecked_isa_dma: 0,	/* no memory DMA restrictions */\
	use_clustering: 0,					\
        use_new_eh_code: 0, 	/* enable this field next time*/\
        emulated: 0, 						\
} 
#endif


#endif /* _ft3xx_h */ 
